<template>
  <div class="-position-relative">
    <div class="_filters _filters--no-top">
      <div class="_filters__section">
        <div class="_filters__section__title">{{ $t('js.tasks.status') }}</div>
        <label><input v-model="filters.showDone" type="checkbox"> {{ $t('js.tasks.show_done') }}</label>
      </div>
      <template v-if="subject">
        <div class="_filters__spring" />
        <div class="_filters__section">
          <rui-button variant="creative" icon="plus" :caption="$t('generic.new_task')" @click="$emitBus('show-task-form', subject)" />
        </div>
      </template>
    </div>

    <div class="_container">
      <rui-loading v-if="loading" fill relative>{{ $t('generic.loading') }}</rui-loading>

      <rui-alert v-else-if="loadingError" variant="danger" centered>
        <p>{{ $t('js.generic.loading_data_error') }}</p>
        <rui-button :disabled="loading" @click="loadTasks">{{ $t('js.generic.retry') }}</rui-button>
      </rui-alert>

      <rui-empty v-else-if="Object.keys(tasksByDay).length === 0" :content="$t('js.todos.index.no_tasks')" icon="smiley">
        <template #actions>
          <rui-button v-if="subject"
                      icon="plus"
                      :caption="$t('generic.new_task')"
                      variant="creative"
                      @click="$emitBus('show-task-form', subject)" />
        </template>
      </rui-empty>

      <section v-for="(data, day) in tasksByDay" :key="day" class="gpa-tasks__day" :class="dayCSS(data)">
        <h2>{{ day }}</h2>
        <gpa-task v-for="task in data.tasks" :key="task.id" :task="task" />
      </section>
    </div>
  </div>
</template>

<script>
import RuiAlert from '@experiments-labs/rise_ui/src/components/Alert/Alert.vue'
import RuiButton from '@experiments-labs/rise_ui/src/components/Button/Button.vue'
import RuiEmpty from '@experiments-labs/rise_ui/src/components/DataDisplay/Empty/Empty.vue'
import RuiLoading from '@experiments-labs/rise_ui/src/components/Loading/Loading.vue'

import { isOver, isSameDay } from '@experiments-labs/rise_ui/src/lib/Dates'
import GpaTask from './_Task.vue'
import Element from '../../../../classes/models/Element'
import Map from '../../../../classes/models/Map'
import Path from '../../../../classes/models/Path'
import Patch from '../../../../classes/models/Patch'

export default {
  name: 'GpaTasks',
  components: { RuiAlert, RuiEmpty, RuiButton, RuiLoading, GpaTask },
  props: {
    /** Subject to filter tasks. Shows all tasks when null */
    subject: { required: false, type: [Element, Map, Patch, Path], default: null },
  },
  data () {
    return {
      loadingError: false,
      loading: false,
      filters: {
        showDone: false,
      },
      now: new Date(),
    }
  },
  computed: {
    tasksByDay () {
      let tasks
      if (this.subject) tasks = this.$store.getters.tasksBySubject(this.subject)
      else tasks = this.$store.getters.tasks

      return tasks
        .slice()
        .reverse()
        // Group by day
        .reduce((result, task) => {
          const date = task.doneAt ? task.doneAt : task.plannedFor
          const humanDate = this.$d(date, 'date')
          if (!result[humanDate]) result[humanDate] = { date, tasks: [] }
          result[humanDate].tasks.push(task)
          return result
        }, {})
    },
  },
  methods: {
    loadTasks () {
      this.loading = true
      this.loadingError = false
      let promise

      const filters = {
        status: this.filters.showDone ? null : 'pending',
      }

      if (this.subject) promise = this.$store.dispatch('loadTasksForSubject', { subject: this.subject, filters })
      else promise = this.$store.dispatch('loadTasksAllForMap', { mapId: this.$route.params.mapId, filters })

      promise.catch(() => { this.loadingError = true })
        .then(() => { this.loading = false })
    },
    dayCSS (dateAndTask) {
      const todos = dateAndTask.tasks.filter((t) => !t.doneAt).length
      return [
        this.isOver(dateAndTask.date) && todos > 0 && 'gpa-tasks__day--overdue',
        this.isSameDay(dateAndTask.date) && todos > 0 && 'gpa-tasks__day--today',
      ]
    },
    isSameDay (date) { return isSameDay(date, this.now) },
    isOver (date) { return isOver(date, this.now) },
  },
  created () { this.loadTasks() },
  watch: {
    filters: {
      handler () { this.loadTasks() },
      deep: true,
    },
  },
}
</script>

<style lang="scss" src="./Tasks.scss" />
